local M = {}

local running = true
local scenario = nil
local speed = 0
local crash = 0

local helper = require('scenario/scenariohelper')

local function reset()
    running = false
	crash = 0
end

local function fail(reason)
    scenarios.finish({failed = reason})
    reset()
end

local function success(speed)
    --local result = {msg = 'Target damage done: $'..string.format("%0.2f", speed)..''}
    scenarios.finish(result)
    reset()
end

local function onRaceStart()
    reset()
	
	local result = {msg = 'Target damage done: $'..string.format("%0.2f", speed)..''}

    helper.setAiMode('aiCar1', 'manual')
    helper.setAiAggression('aiCar1', 1)
    helper.setAiTarget('aiCar1', 'RookerEB_AP')
    helper.trackVehicle('aiCar1', 'aiCarA')

    helper.trackVehicle('scenario_player0', 'playerCar')

    running = true
end

local function onRaceTick(raceTickTime)
    if not running then
        return
    end

    local aiCarAData = map.objects[map.objectNames['aiCarA']]
    local playerCarData = map.objects[map.objectNames['playerCar']]

    if not aiCarAData or not playerCarData then
        return
    end

    if aiCarAData.damage > 0 and speed == 0 then
        speed = playerCarData.vel:length()
    end

    if aiCarAData.damage >= 1500.0 then
		helper.setAiMode('aiCar1', 'stop')
    end
	
    if scenario.timer > 40 then
		targetDamage = aiCarAData.damage
		--trafficDamage = (aiCarAData.damage + aiCarBData.damage) * 4
		trafficDamage = 0
		totalDamage = targetDamage - trafficDamage
		if targetDamage >= 5000 then
			if totalDamage >= 5000 then
				result = {msg = 'Target damage done: $'..string.format("%0.2f", targetDamage)..' You see the logo on the van? Learn to hate that logo.'}
				success(targetDamage)
			else
				fail("You did too much damage to the traffic!")
			end
		else
			fail("You didn't do enough damage to the target! Target damage done: $"..string.format("%0.2f", targetDamage).."")
		end
    end
end

local function onScenarioChange(sc)
    scenario = sc
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onScenarioChange = onScenarioChange

return M